#include <cstdio>
#include <vector>
#include <cstring>
#define maxn 50100

using namespace std;

struct trie {
	int fiu[2];
	int sum[2];
};

int n, m, T, i, j;
int tip, c, t, p, q, a, b, x;
vector <trie> st[1<<17];
trie aux;
int f0, f1;
int nrt, qt[80];

inline int bit_x(int nr, int x) {
	return (!!(nr & (1 << (16 - x))));
}

inline void baga_trie(int poz, int q, int t, int p) {
	int i, bit, nod, vf = 0;
	int stack[20];

	nod = 0;
	for (i = 1; i <= 16; i++) {
		bit = bit_x(t, i);

		vf++; stack[vf] = nod;
		st[poz][nod].sum[p] += q;

		if (st[poz][nod].fiu[bit] == 0) {
			st[poz].push_back(aux);
			st[poz][nod].fiu[bit] = st[poz].size() - 1;
		}

		nod = st[poz][nod].fiu[bit];
	}

	st[poz][nod].sum[p] += q;
}

inline void update1(int nod, int left, int right, int c, int q, int t, int p) {
	int m = (left + right) / 2;
	baga_trie(nod, q, t, p);

	if (left == right)
		return;
	if (c <= m)
		update1(2 * nod, left, m, c, q, t, p);
	else
		update1(2 * nod + 1, m + 1, right, c, q, t, p);
}

inline void update_trie(int poz, int t, int f0, int f1) {
	int i, bit, nod;
	nod = 0;
	for (i = 1; i <= 16; i++) {
		st[poz][nod].sum[0] = st[poz][nod].sum[0] - f0 + f1;
		st[poz][nod].sum[1] = st[poz][nod].sum[1] - f1 + f0;
		bit = bit_x(t, i);
		nod = st[poz][nod].fiu[bit];
	}

	st[poz][nod].sum[0] = st[poz][nod].sum[0] - f0 + f1;
	st[poz][nod].sum[1] = st[poz][nod].sum[1] - f1 + f0;
}

inline void get_f(int poz, int t) {
	int i, bit, nod;
	nod = 0;
	for (i = 1; i <= 16; i++) {
		bit = bit_x(t, i);
		nod = st[poz][nod].fiu[bit];
	}
	f0 = st[poz][nod].sum[0];
	f1 = st[poz][nod].sum[1];
}

inline void update2(int nod, int left, int right, int c, int t) {
	int m = (left + right) / 2;

	if (left == right) {
		get_f(nod, t); 
		update_trie(nod, t, f0, f1); 
		return;
	}

	if (c <= m)
		update2(2 * nod, left, m, c, t);
	else
		update2(2 * nod + 1, m + 1, right, c, t);

	update_trie(nod, t, f0, f1);
}

inline void query(int nod, int left, int right, int x, int y) {
	int m = (left + right) / 2;
	if (x <= left && right <= y) {
		nrt++;
		qt[nrt] = nod;
		return;
	}

	if (x <= m)
		query(2 * nod, left, m, x, y);
	if (y > m)
		query(2 * nod + 1, m + 1, right, x, y);
}

inline int query_trie(int x, int p) {
	int i, j, nod[80], sol = 0, sum, fiu;
	memset(nod, 0, sizeof(nod));

	for (i = 1; i <= 16; i++) {
		sum = 0;
		for (j = 1; j <= nrt; j++) if (nod[j] >= 0) {
			fiu = st[qt[j]][nod[j]].fiu[0];
			if (fiu != 0)
				sum += st[qt[j]][fiu].sum[p];
		}

		if (x <= sum) {
			sol = sol * 2;
			for (j = 1; j <= nrt; j++) if (nod[j] >= 0) {
				if (st[qt[j]][nod[j]].fiu[0] == 0)
					nod[j] = -1;
				else
					nod[j] = st[qt[j]][nod[j]].fiu[0];
			}
		}
		else {
			x -= sum;
			sol = sol * 2 + 1;
			for (j = 1; j <= nrt; j++) if (nod[j] >= 0) {
				if (st[qt[j]][nod[j]].fiu[1] == 0)
					nod[j] = -1;
				else
					nod[j] = st[qt[j]][nod[j]].fiu[1];
			}
		}
	}

	return sol;

}

void init_trie() {
	for (i = 1; i < 131072; i++)
		st[i].push_back(aux);
}

int main() {
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w", stdout);

	scanf("%d%d%d", &n, &m, &T);

	init_trie();

	for (i = 1; i <= T; i++) {
		scanf("%d", &tip);
		if (tip == 1) {
			scanf("%d%d%d%d", &c, &t, &p, &q); 
			update1(1, 1, n, c, q, t, p);
		}

		if (tip == 2) {
			scanf("%d%d", &c, &t);
			update2(1, 1, n, c, t);
		}	

		if (tip == 3) {
			scanf("%d%d%d%d", &a, &b, &p, &x);
			nrt = 0;
			query(1, 1, n, a, b);
			printf("%d\n", query_trie(x, p));
		}	
	}

	return 0;
}

