/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/*
  Time Complexity: O(N*logN)
  - using binary tries
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define filein "string.in"
#define fileout "string.out"
#define maxn 500010
#define maxl 19

typedef struct trie { trie *pa,*pb; };

trie *root;
char s[maxn],found[maxl+1],stack[maxl+1],ch;
long i,j,k,m,n,l,memoc=maxn+2*maxl+4+1+28;

void read();
void buildtrie();
void compute();
void print();

int main()
{
read();
buildtrie();
compute();
print();
return 0;
}

void read()
{
FILE *fin=fopen(filein,"r");
fscanf(fin,"%ld%c",&n,&ch);

for (i=0;i<n;i++)
  {
  fscanf(fin,"%c",&ch);
  s[i]=ch;
  }

s[n]=0;
}

void inserttrie(long start)
{
long i;
trie *aa,*aux;

for (aa=root,i=start;i<n && (i-start)<maxl;i++)
  if (s[i]=='a')
    {
    if (aa->pa!=NULL)
      aa=aa->pa;
    else
      {
      aux=new trie;
      aux->pa=NULL;
      aux->pb=NULL;
      aa->pa=aux;
      aa=aux;

      memoc+=sizeof(trie);
      }
    }
  else
    {
    if (aa->pb!=NULL)
      aa=aa->pb;
    else
      {
      aux=new trie;
      aux->pa=NULL;
      aux->pb=NULL;
      aa->pb=aux;
      aa=aux;

      memoc+=sizeof(trie);
      }
    }
}

void buildtrie()
{
long i;

root=new trie;
root->pa=NULL;
root->pb=NULL;
memoc+=sizeof(trie);

for (i=0;i<n;i++)
  inserttrie(i);
}

void df(trie *po,long niv)
{
if (po->pa==NULL)
  {
  l=niv+1;
  for (i=0;i<niv;i++)
    found[i]=stack[i];
  found[niv]='a';
  }
else
if (po->pb==NULL)
  {
  l=niv+1;
  for (i=0;i<niv;i++)
    found[i]=stack[i];
  found[niv]='b';
  }
else
  {
  if (niv+2<l && niv+1<maxl)
    {
    stack[niv]='a';
    df(po->pa,niv+1);
    }

  if (niv+2<l && niv+1<maxl)
    {
    stack[niv]='b';
    df(po->pb,niv+1);
    }
  }
}

void compute()
{
l=100;
df(root,0);
}

void print()
{
long i;

freopen(fileout,"w",stdout);
printf("%ld\n",l);

for (i=0;i<l;i++)
  printf("%c",found[i]);

printf("\n");

/*
printf("%ld\n",memoc);
*/
exit(0);
}

